#!/bin/sh
#
### rc.z_B2T copied into "B2U", without the main_GUI dialog Selection .
#
### testing GTK-dialog simplified with flag control of progress dialog.
### testing with default GTK-cialog colors (black/lightblue) .

### 'B2U.sh' , format so GEANY sees a 'script' executable .
### 'rc.z_B2U.sh' , prefix is to indicate preferred location of program script.
#
########################################################################
#
#  Standard GNU General Public License Header :
#
#  2020 root <glen.e77is@Gmail.com>
#  website : www.GeoCities.WS/glene77is
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  To received a copy of the GNU General Public License
#  write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
#######################################################################
#  tar (GNU tar) 1.29
#  Copyright (C) 2015 Free Software Foundation, Inc.
#  License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
#  This is free software: you are free to change and redistribute it.
#  There is NO WARRANTY, to the extent permitted by law.
#  Written by John Gilmore and Jay Fenlason.
#
#######################################################################
### Developed using Geany,
### with option "Execute" for trace in "BASH Terminal" for debug.
### All of our "echo" lines will show trace in this terminal screen.
### Using Geany with option "Execute" will allow good debugging in "BASH Terminal"
#
########################################################################
#
#
#
########################################################################
# pupsave-back-2-tar ("B2T")
### ### /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
#
# 2byte wrote the original pupsave-backup v.1.2.1, 2011 .
# Sigberg rewrote into the Fuller version, v.1.3,  2013 .
# glene77is rewrote totally into simpler form, as B2T, 2019-2020 .
# website : www.GeoCities.WS/glene77is
#
############################################################################################
# gae developed 'pup_backup-to-tar', "B2T". 201911 <-> 202005.
# B2T : our code was based on the idea behind pupsave-backup 1.2.1
# see Murga http://murga-linux.com/puppy/viewtopic.php?p=1050224#1050224
# B2T version is running on 'UpupBB-19.03 +20'
# B2T uses gtkdialog -v = 0.8.4 release , Laszlo Pere, Thunor.
# B2T has been tested on Puppy distros :  Slacko, Xenial, Tahr, UpupBB .
# B2T has been tested on saveFOLDER and saveFILE.4fs systems.
# B2T depends on gtkdialog for Progress Dialog, Help-splash and Main-Gui-splash screens.
# B2T depends on Puppy Linux "PUPSTATE" file for system variables.
# B2T has been designed/tested to work with Puppy Linux Frugal installs.
# B2T has been designed/tested to work with Puppy Linux formats Ext2,3,4.
# B2T has been tested to work with Puppy Linux Frugal, saveFOLDER systems.
# B2T has been tested to work with Puppy Linux Frugal, saveFILE.4fs systems.
# B2T has many 'echo' trace messaages, which appear in the Geany, Execute, Terminal window.
############################################################################################
#
#
#
#########################################################################################
### 191113-1116
###     gae, first bug killed was the lingering splash banner
###         which persisted, and was not killed properly at end of program.
###         and persisted forever on desktop, until Refresh "X" or "Reboot"
###     gae, that bug, and other complexities, led to total re-write
###             from scratch.
###     gae, Design Philosophy : "Simple, Readable, Modifiabled"
###
###
### 191114-0800, gae, defaulted "tar.gz" option
### 191122, gae, inserted proper credits for authorship and modifications.
### 191123, gae, cleanup
### 191127, gae, touch-up notes
### 191201, gae, cull extra dialog box, write compact date, gae
### 191203, gae, adjust credits, mod help.
### 191210, gae, minor touch-ups.
### 191212, gae, ERRORMSG is OK, sometimes empty, sometimes has string
### 191218, gae, touch-up
### 191231, gae, touch-up
### 200107, gae, touch-up
### 200120, gae, touch-up
### 200129, gae, more tracing of functions.
###         Some original functions are not used, will be culled.
###
### 200130, trace & debug.
### 200130,1417
### 200131,1050
### 200202-0834
### 200207-0500 gae, backtracked several days to 200203, to rewrite a bug.
###
###     Original has always had bug " du : zero length filename " from terminal window.
###     Original Code calls "du" two times.  if 'B2T_Backup', then "du" Needs tracing.
###
###     Still trace "destfile" et al
###     in order to pull source and destination file names from PUPSTATE var PUPSAVE.
###     The orig code was developed in layers,
###     and has needlessly roundabout expressions
###     and lacks required documentation.
###
### 200208-0500 gae, use Geany with [ Execute / Terminal / echo "" ] function .
###
### 200208-1400 gae
### 200208-1832 gae PUPSTATE var OK ! in calling tar -c -z -f  lcPupTrg lcPupSrc !
### 200208-2226
### 200209-0538 gae, restore from 08, continue stripping extraneous code.
### 200209-1400 gae, continue stripping extraneous code.
### 200209-1535 gae, publish to Murga
### 200209-1950 gae, bug in MBavailable
### 200210-0430 gae, MBavailable works.
### 200210-1742 gae, checking last block "$EXIT" = "BACKUP"
### 200210-1851 gae, DateTimeStamp now includes %S seconds(01-60). Dupe prohibited.
### 200211-1124 gae, restored.
### 200211-1321 gae, ok
### 200211-1405 gae, ok
### 200211-1416 gae, ok
### 200212-2000 gae, ok
### 200213-0424 gae, added title "B2T" in Main Gui
###                  trace savePATH vs saveFOLDER via CAMB .
### 200213-1700 gae, rebuild into 20212-2000
### 200216-0630 gae, continued trace and mod.
### 200217-0400 gae, continued trace and mod.
### 200217-0742
### 200220-0603
### 200221, gae
### 200224-0615 gae, /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
### 200224-2105 gae, Tested on EXT2,3,4 formated partitions.
### 200226-0600 gae, Total ReWrite from near scratch.
### 200229-1625 gae, TEST routines transferred to rc.z_TST
### 200301-0552
### 200301-1622
### 200302-0525
### 200302-1830
### 200304-0400
### 200304-1520
### 200306-1511
### 200310-0430 gae, re-wrote the Main()-GUI
###             tested alternative branching code.
### 200314-0408
### 200315-1313
### 200317-1813
### 200320-0600
### 200321-0730
### 200321-0930 gae, copied "SYS_" subroutines from 'MGN"
### 200323-1500 gae, tested B2T vs B2T code, OK.
### 200324-1500
### 200324-1800
### 200325-0856 gae, install Sys_ShowSplash
### 200325-0950 gae, smoothing repeated applications of Sys_ShowSplash
### 200327-0400
### 200330-0943
### 200331-0606
### 200404-1643
### 200408-0620
### 200411-0400
### 200412-0700
### 200414-0930
### 200415-0534
### 200418-0939
### 200419-1304 gae, restored, Sys_ShowSplash bug.
### 200419-1709
### 200426-0933
### 200427-0455
### 200427-1044 gae, embedded TAROPT near "tar" run command .
### 200430-1012 gae, restored from last good script, in /etc/rc.d
### 200430-1826 gae, removed Sys_ShowSplash bug.
### 200501-1616 gae, house-cleaning.
### 200502-0700 gae, removed gtk-dialog for test, to DavidS45, removed GTK
### 200502-0730 gae, removed gtk-dialog for test, to DavidS45, Simplified GTK , no colors
### 200502-1502 gae, MGN calling for 'No-Gui' .
### 200502-1951 gae, imported orig 'B2T_Show_Splash' from HB v.1.2., to test.
### 200503-0500 gae, flag for controlling gtkdialog 'splash' screens, flags at head of "main splash" .
###     NOTE: from DavidS45
###     /usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "
###     inhibits gtkdialog display in Wheezy.
###     That led to developing a version with No GtkDialog splashes.
###     Made use of gtkdialog splashes to HB.v.1.2 default.
###     Wheezy problem persisted, along with other ancient Puppy Distro systems.
###     Decision not to pursue extreme "BackWard Compatibility".
###
### 200504-0610 gae, saved as B2Tcfg.sh dts .  Dev Cfg needs more work.
###                 restore & resume cleaning B2T code
###                 Decided Cfg is mandatory, stopped development.
###                 Cfg conflicts with "Simple" guideline.
### 200504-0900 gae, tested gtkdialog splashes , again.
### 200505-0600 gae, Set gtkdialog splashes to HB.v.1.2 default.
### 200506-0700 gae, housekeeping
### 200506-1045 gae, develop a 'looping' BackUpRun, ReStart.
### 200506-1127 gae, develop loop based on "eval" , rm lock-file, exit
### 200506-2036 gae, housekeeping
### 200508-0430 gae, begin dev on "p-Cold-Backup" 'for Puppy SaveDATA' .
### 200509-0713 gae, housekeeping
### 200509-1518 gae, housekeeping
### 200510-0833 gae, housekeeping
### 200511-0541 gae, updated Progress trace
### 200511-1723 gae, transferred code base from B2T to B2T. Works first time.
###                     continued "Readability" mods
### 200512-0600 gae, housekeeping, added Sys_Str2Trm
### 200514-0625
### 200515-1527
### 200519-0723
### 200522-0746 gae, inserted Str2Trm 
### 200522-2015 gae, update
### 200525-0800 gae, added splash to tar trace, and notes at end of terminal display. 
### 200529-0600 
### 200531-0500 
### 200602-0800
### 200604-1100 gae, cleanup
### 200605-0700 gae

#########################################################################################



### NOTE: --- B2T/B2T_Backup -------
### PUPSTATE has PUPSAVE as the name of the savedata in use !
### savedata can be "upupbb-???.4fs" or "/upupbb-???" .
### savedata can be a FILE or a FOLDER.
### B2T takes the savedata as Source name and runs thru Tar.Gz .
### Tar does not care what kind of file or folder is Source data.
### Tar does not care what kind of file or folder is Source data.
###


#########################################################################################

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_SetVerDts() {
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    #
    ### called by Main ()
    ### param
    ### purpose : generate system date/time constants.
    ### rationale : One Time Manual Entry
    ### note :
    #
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####

###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export gcVerDts="200605-0700"
### developer enters this manually for Each Version Development.
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

    ###  Dts="`date +%y%m%d-%H%M-%S`"
    ### addust from default "z" time 
    ###   to local mid-america dts ( =5 hours ).
    lcNowDts=""
    lcNowDts="`date +%y%m%d%H%M`"
    lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:4}"
    gcNowDts="${lcNowDts}-local"
    export gcNowDts="${lcNowDts}"


###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export lcSysDts="`date +%y%m%d-%H%M-%S`"
### Now Date : grave-mark in date () !!!

export lcSysVer="Linux puppypc3073 4.9.163-lxpup-32-pae #1 SMP Thu Mar 14 15:41:19 GMT 2019 i686 i686 i686 GNU/Linux"

export lcSysNameBase="B2U"	### used in code as label

    ### trace results to terminal screen.
    lcMsgStr="VerDts: ${gcVerDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"
    lcMsgStr="SysDts: ${lcSysDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"
    lcMsgStr="NowDts: ${lcNowDts} ......." && Sys_Str2Trm   "${lcMsgStr}"   "3" "10"

    ### this is a compact, non-Y2K-compliant date, gae
    ### remember to use grave-mark "`" in "date" function parameters.
    ### grave-mark is with the tilde "~" key, top row, left end.

}   ### end Sys_SetVerDate

### call 'Sys_SetVerDate' from Main ()
### current DTS is used below in Main_GUI () and Help_Box ()
#
### gcVerDts is declared/assigned at beginning (top) of program
### function B2T_SetVerDate is called at top of '=== MAIN () ==='
#########################################################################################





########################################################################
### rc.zStr2Trm	########################################################
########################################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function Sys_Str2Trm() {   ### active
### B2T_Str2Trm #######################################################

### purpose: Message routine for Geany "terminal" use.
### usage:
###    Sys_Str2Trm "string" "color" "margin"
###    Sys_Str2Trm "$lcMsgStr" "grn" "3"
###    lcMsgStr="xxx" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

### dev param error check
### [ -z "${1}" ] && lcParStr="message"	### string
### [ -z "${2}" ] && lcParClr="5"	### color : 1,2,3,4,5   or  red,grn,yel,blu,pur
### [ -z "${3}" ] && lcParMrg="3" ### margin : 1,2,3,4,5 where mrg=5,10,15,20,25,30

##### begin: rc.zStr2Trm ##################################################
##### begin: rc.zStr2Trm ##################################################
##### begin: rc.zStr2Trm ##################################################

### capture all params
lcParStr=${1}	### string message
lcParClr=${2}	### color name or number, loaded two times
lcParMrg=${3}	### margin number 1,2,3,4,5,etc

### rc.zStr2Trm	########################################################
### trap margin from #3 param |"number"   ### default left-margin=3 ###
#
case "${lcParMrg}" in
#
0|"0") /bin/echo -n -e ""  ;; 
1|"1")   /bin/echo -n -e "\\033[1G"  ;; 
2|"2")   /bin/echo -n -e "\\033[2G"  ;;
3|"3") /bin/echo -n -e "\\033[3G"  ;; 
4|"4")   /bin/echo -n -e "\\033[4G"  ;; 
5|"5") /bin/echo -n -e "\\033[5G"  ;;
5|"6") /bin/echo -n -e "\\033[6G"  ;; 
5|"7")   /bin/echo -n -e "\\033[7G"  ;; 
5|"8") /bin/echo -n -e "\\033[8G"  ;;
5|"9") /bin/echo -n -e "\\033[9G"  ;; 
10|"10")  /bin/echo -n -e "\\033[10G"  ;; 
15|"15") /bin/echo -n -e "\\033[15G"  ;;
20|"20") /bin/echo -n -e "\\033[20G"  ;; 
30|"30") /bin/echo -n -e "\\033[30G"  ;; 
*) /bin/echo -n -e "\\033[3G"  ;;
esac
#
### rc.zStr2Trm	########################################################
### trap color from #2 param "name"|"number"   ### default is "yel" 
#
case "${lcParClr}" in
#
red|"1") /bin/echo -n -e "\\033[1;31m"  ;;
grn|"2") /bin/echo -n -e "\\033[1;32m"  ;;
yel|"3") /bin/echo -n -e "\\033[1;33m"  ;; 
blu|"4") /bin/echo -n -e "\\033[1;34m"  ;;
pur|"5") /bin/echo -n -e "\\033[1;35m"  ;;
cyn|"6") /bin/echo -n -e "\\033[1;36m"  ;;
wht|"7") /bin/echo -n -e "\\033[1;37m"  ;;
wblu|"8") /bin/echo -n -e "\\033[4;7;30m"  ;; ### blu
wgrn|"9") /bin/echo -n -e "\\033[3;7;30m"  ;; ### grn
wgry|"10") /bin/echo -n -e "\\033[5;7;30m"  ;; ### gry
*)	/bin/echo -n -e "\\033[1;33m"  ;;
esac
#
### rc.zStr2Trm	########################################################
	/bin/echo -n "$lcParStr"  
	/bin/echo -e "\\033[0;m" 
	return  0
###
}   ### end: Sys_Str2Trm
##### end: Sys_Str2Trm ##################################################







#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function B2T_Show_Splash() {    ### from orig Hot-Backup v.1.2
    ### called by Alternate "DONE" progress dialog splash.
    ### intended to be a 'bare minimum' progress dialog splash.
    ### receives no 'color' param , should show default black/grey .
    ### receives param only for "text"
	/usr/lib/gtkdialog/box_splash -close never -text "$@" &
	pidx=$!
}   ### end: B2T_Show_Splash
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----
function B2T_Splash_Trace() {   ### not active
    ### purpose : Basic Message-2-String Terminal Display 
    ### has been replaced by Sys_Str2Trm()
    lcParMsg=${1}
    lcParClr=${2}
    echo -n -e "\\033[0G\\033[1;32m"    #green [done] msg.
    echo -n "***${lcParMsg}"    #done
    echo -e "\\033[0;39m"   
}   ### end B2T_Splash_Trace
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----



#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function Sys_PupState(){    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ###
    ### called by B2T_StartUp ()
    ### param : requires Linux Puppy  /etc/rc.d/PUPSTATE  system reference file.
    ### purpose :
    ###     consolidation of PUPSTATE into this program .
    ###     control generation of local var and system var .
    ### rationale :
    ###     Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    ###     Puppy OS write the 'whole known universe' into this file !!!
    ###     this routine reads the "state" file
    ###     this routine declares/assigns more B2T var.
    ### sends :
    ### note :
    #
    #~ lcMsgStr="   running Sys_PupState"
    #~ Sys_Str2Trm "$lcMsgStr" "yel" "3"
    #
    #
    ### begin: maintain gcVerDts ( Developer's DTS ) .
    lcVerDtsTmp="${gcVerDts}"
    #
    #--- load PUPSTATE --- from only location : "/etc/rc.d/"
    #--- Puppy OS write the 'whole known universe' into this file !!!
    #--- At end of rc.sysinit,
    #------the user can append more lines to match his deloping system.
    . /etc/rc.d/PUPSTATE
    #
    gcVerDts="${lcVerDtsTmp}"
    ### end: maintain gcVerDts ( Developer's DTS ) .
    #
    ### direct import, similar varname.
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    lcPupSubDir=${PSUBDIR}
    lcPupHome=${PUP_HOME}
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}

    lcPupDts="`date +%y%m%d-%H%M-%S`"   ### not used

### maintain similarity to PUPSTATE "name"
    lcPupSaveNameRaw="PUPSAVE : ${lcPupSve}"  # B2T 'raw' savefilename from PUPSTATE file
    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" # B2T 'cut' savefilename from PUPSTATE file
    lcPupSaveNameBKP="${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`"     ### grave-mark in date () !!!
    lcPupSaveNameTrg="${lcPupSaveNameBKP}.tar.gz"
    lcPupSaveNameSrc="${lcPupSaveName##*/}"
    lcPupSubDir="${lcPsubDir}.BKP-`date +%y%m%d-%H%M-%S`"      ### grave-mark in date () !!!
    lcPupDistroVer=${gcSysDistroVer}  ### 'BionicPup32-19.03+18 +++'-sig

###--- Sys_PupState ---

###    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" # savefilename

########################################################################
lcB2Tname="B2T"
lcB2Tdts="${gcVerDts}"
lcB2Tsleep="sleep 3"

########################################################################
    ###
    ### Later in the B2T Code, you will find several "export" expressions.
    ### 'export' empowers the "B2T_Main_Gui", this is a "requirement" for Main GUI.
    ### 'export' Marks each NAME for automatic export to the environment
    ###    of subsequently executed commands.
    ### If VALUE is supplied, assign VALUE before exporting.
    #
}   ### end: Sys_PupState




#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function B2T_StartUp() {    ### active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    #
    ### called by : Main ()
    ### param :
    ### purpose :  generalized StartUp process
    ### rationale :
    ### note: all the 'echo' are displayed in Geany, Execute, Terminal
    #

    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"
    lcMsgStr="begin: function B2T_StartUp ..." && Sys_Str2Trm   "${lcMsgStr}"   "yel" "10"
    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"
    lcMsgStr="calling System files  ...." && Sys_Str2Trm   "${lcMsgStr}"   "yel" "10"

    lcMsgStr=">>> call Sys_SetVerDts for date based variables... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    Sys_SetVerDts   ###     ### B2T_StartUp calls

    lcMsgStr=">>> call Sys_PupState for System Constants ... " && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    Sys_PupState        ### B2T_StartUp calls

    lcMsgStr="trace: Export var" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
    export lcB2Tname lcB2Tdts lcB2Tsleep

    #~ lcMsgStr="trace: Export B2T_Help_Box .... for Main_GUI ()" && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
    #~ export -f B2T_Help_Box     ### GTKdialog must be visible to Main-Dialog
    #~ export -f B2T_Src_Box 

    ### Vital: re-assignment of data into 'lcSaveData' !!!
    ### required to calculate "Backup Free Disk Space" for mainGUI
    ### req by function B2T_MB_required
    ### gen in function B2T_StartUp as "lcSaveData"
    lcSaveData="`echo $lcPupSave | cut -f 3 -d ","`"

    lcMsgStr="Export more variables .... for Main_GUI ()" && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    ### export these items
    ### so to be visible to the Main_GUI ()
    ### may use these, possibly.

    lcMsgStr="Export variables " && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    export GTK2_RC_Files="/root/.gtkrc-2.0"
	export SAVEFOLDER=1
	export REFRESH_INTERVAL=1000 #1 seconds

    lcMsgStr="Export Path,Name,etc. " && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    export B2T_PUPSAVE_PATH="/mnt/home${lcSaveData}"
    export B2T_PUPSAVE_NAME="${SF##*/}" ### ${SF##*/} = basename $SF not properly assigned.
    export B2T_PUPSAVE_Fn="${B2T_PUPSAVE_NAME}.BKP-`date +%y%m%d-%H%M-%S`"

    lcMsgStr="Export function names " && Sys_Str2Trm "${lcMsgStr}" "yel" "3"
    export -f  B2T_Show_Splash
    #~ export -f  B2T_MBrequired
    #~ export -f  B2T_TrgFilename
    export -f  B2T_BackUpRun

    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"
    lcMsgStr="end: function B2T_StartUp ..." && Sys_Str2Trm   "${lcMsgStr}"   "yel" "3"
    lcMsgStr="----------------------------------------" && Sys_Str2Trm   "${lcMsgStr}"   "blu" "10"

} ### end B2T_StartUp





#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function B2T_BackUpRun() {     ### Active
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    ### called by:  Main_Gui , EXIT:BackStd , B2T_BackUpRun

    ### called by: Main, Main_GUI, Check-After-Main-Gui, EXIT:???Back .
    ### param (1) : $B2T_PUPSAVE_PATH
    ### param (2) : $B2T_BACKUP_PATH
    ### purpose: Build DestFileName : $B2T_PUPSAVE_PATH $B2T_BACKUP_PATH
    ### send :
    ### note :
    ###     When Running in 'Geany', use the 'Execute', 'BASH Terminal' mode,
    #
    ###     during backup process, "du" has error msg .
    ###     "   du: invalid zero-length file name  "
    ###     Which is displayed in the Terminal window.
    ###     Which arises when parsing past end of stack,
    ###     Which is NON-fatal.
    #
    lcMsgStr=">>> Start fx BackUpRun" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    ### sync     ### write all buffered blocks to disk
                ### will lock if SnapMergePuppy is running. 
                ### will not run if PartEd is busy. 
	sleep 1

    ### "CWDIR" is anacronym for "Current Working Directory" .
    ### "PWD"   is system var "/root" .

    ### param (1) is $B2T_PUPSAVE_PATH
    lcMsgStr="B2T_BackUpRun ==============================================" && Sys_Str2Trm "$lcMsgStr" "blu" "3"
    lcMsgStr="trace: >>> $ { 1% } is ${1} <<< param #1" && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="trace: >>> $ { 1% /* } is ${1%/*} <<< subdir of source saveDATA" && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="trace: CWDIR=$PWD  <<<." && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="trace: CWDIR points to '/root' path level." && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="B2T_BackUpRun ==============================================" && Sys_Str2Trm "$lcMsgStr" "blu" "3"
    CWDIR=$PWD  ###

    ### now, CWDIR points to "/root" path level.
    #
    ### this "flipping" between PWD and CWD is necessary because
    ###     program is receiving full /mnt/home/path/subdir/filenames
    ###     whereas
    ###     'tar' is using a "local" /path/subdir/filenames
    ### Perhaps we will write a future version of B2T
    ### including a re-write the file-name handling methods
    ### to be more simple, and still pull data from 'PUPSTATE' .
    ###
    ### In this version of B2T :
    ### we flip to 'local' /path/subdir
    ###     when calling 'tar' for saveData .
    ### we flip to '/root'  /path/subdir/filename.4fs
    ###     when calling for saveData .
    ### we flip back to 'local' after 'tar' runs .
    ###
    ### B2T system runs from /root ,
    ### but 'tar' uses the short-form file-names .
    ###
    ### -----------------------------------------------------------------
    ### B2T  gets control info from the system
    ###    via the system file "/etc/rc.d/PUPSTATE"
    ###    PUPSTATE is always valid at runtime for this OS.
    ### -----------------------------------------------------------------
    ###
    ### NOTE: about paramters sent to 'tar'
    ### 'tar' does not care what kind of data is the Source Data .
    ### SaveDATA can be "upupbb-???.4fs" or "upupbb-???"
    ###    or some other subdir or file .
    ### B2T takes the saveDATA as Source name and runs it thru 'Tar' .
    ###  source can be  /subdirname , containing Linux data set .
    ###  source can be  file.4fs , containing a '.4fs' Linux data set .
    ###  source can be  anything that 'tar' can read .
    ### B2T could be written to handle back-up for any file set.
    ### -----------------------------------------------------------------

    ####################################################################
    ### B2T_Tar_Opt is hard coded
    ### will set assign value to var 'TAROPT' and 'TAREXT'
    ### gae,
    ###     simple default to "tar.gz" format for 'simple local backup'
    ###     with No Questions Asked.
    ####################################################################

###*********************************************************************
###*********************************************************************
###*********************************************************************
### Main Splash ### MainSplash ### Main-Splash ### Main_Splash ###

### must maintain this measured format so multiple splash fit same format !
### This is "BackGround" Image, subsequent splash will display inside Main.
### box_splash width is 40, fill it so multiple splashes fit good.

lcMsgStr="Main Splash 'please wait' --- Terminal Ctrl-C will kill process ---" && Sys_Str2Trm "$lcMsgStr" "red" "3"
lcMsgStr="Main Splash 'please wait' --- " && Sys_Str2Trm "$lcMsgStr" "red" "3"

### USER MODIFIABLE FLAGS : #############################################

### NOTE: from DavidS45, 200502, Murga.
### /usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "
### inhibits gtkdialog display in very old 'Wheezy'.
### That led to developing this version of B2T
### with "flags" to control the Gui/NoGui Splashes.
### The gtkdialog flags are located at top of "Main_Splash" .


### USER MODIFIABLE FLAGS : #############################################
# lcDialogColor="  -fg black -bg lightblue  " ### this is the default from gtkdialog with 'gradient'='true' .
lcDialogColor="  -fg yellow -bg darkred  "
# lcDialogColor=""    ### default colors NOW are driven by gtkdialog (black/lightblue with gradient).

### USER MODIFIABLE FLAGS : #############################################
llDialogRun="1"     ### "1" is for running the gtkdialog splash .
                    ### "0" is for NO gtkdialog splash .

lcMsgStr="DialogColor: ${lcDialogColor} =======" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
lcMsgStr="DialogRun: ${llDialogRun} =======" && Sys_Str2Trm "$lcMsgStr" "pur" "3"

########################################################################
###*** SPLASH: Main *** MainSplash *** Main_Splash *** Main-Splash *****
###*** SPLASH: Main *** Progress Dialog Splash *************************
###*** SPLASH: Main *** Progress Dialog Splash *************************
###*** SPLASH: Main *** Progress Dialog Splash *************************
########################################################################

lcMsgStr="  MAIN Splash  ... Tar started: ${1%/*}" && Sys_Str2Trm "$lcMsgStr" "red" "3"

### /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text

if [ $llDialogRun -eq "1" ]; then

/usr/lib/gtkdialog/box_splash ${lcDialogColor} -close never -text "
.        ... Please Wait ... ${gcVerDts} ... DEX
.         B2T :  Tar is Creating 'tar.gz' BackUp
.             Wait for USB devices to finish
.
.
.
.              ... Progress Dialog ...
.
.
.
.
. PupSaveNameTrg is : ${lcPupSaveNameTrg##*/} :" &
#-----------------------------------------------------------------------

            GTKPIDmain=$!    ### This is the Main "BackGround" screen.
            sleep 2
else
    ### run the very short form splash
    ### code from HB.v.1.2 original , always with 'default' colors .
    B2T_Show_Splash "${lcMsgStr}..."
            GTKPIDmain=${!}
            sleep 2
fi

    ############################################################
    ### the Main Splash is open as background
    ### other Splash will display inside the Main Splash.
    ############################################################

    ### Subsequent Splash will layer over / blend with the large Main Splash.
    ### Master Splash should linger until after the final dialog splash "Done" is cleared.

    ### Careful !  Maintain sequence of change dir .
    ### change dir from PWD to  ${1%/*}
    ### then run tar .

    ###~ ### this "change dir" is only necessary if PWD was NOT local.
    ###~ ### because B2T will never move away from the "saveDATA" subdir.
    ###~ cd ${1%/*} ### dirname $B2T_PUPSAVE_PATH

    ### tar calls zip with "1" fast compression, Trg , Src
    ### tar -c -z  -f ${destfile##*/} ${1##*/}/    ### fastest

    ###--- B2T_Backup -------
    ### This is Before 'tar' :
    ### echo this trace to terminal
    lcMsgStr="trace: $ {1} is ${1} : last param in buffer " && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="trace: $ {1%/*} <<<<<<< subdir of  saveDATA short form" && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="trace: $ {1%/*} is ${1%/*} <<< last param in buffer." && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    lcMsgStr="trace: cd $ {1%/*} is /mnt/home/pup_UpupBB+20 <<< " && Sys_Str2Trm "$lcMsgStr" "yel" "3"

    ### CD into subdir of "saveDATA"
    ### ... use /path/name chopped, "short form".
    ### so,  ${1} is last param in buffer.
    ### so,  ${1%/*} is "short form" of last param in buffer.
    ### so,  cd ${1%/*} is cd /mnt/home/pup_UpupBB+19

    lcMsgStr="<<< cd ${1%/*} >>>" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
    cd ${1%/*} ### dirname $B2T_PUPSAVE_PATH   <<< loc of savedata

    ############################################################
    ### the Main Splash yellow/red is still open as background .
    ### other Splash will display on top the Main Splash .
    ############################################################


########################################################################
###*** SPLASH: Tar Started *********************************************
###*** SPLASH: Tar Started *********************************************
###*** SPLASH: Tar Started *********************************************

lcMsgStr="Tar started" && Sys_Str2Trm "$lcMsgStr" "red" "3"
lcDialogColor="  -fg yellow -bg green  "

###~ /usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "$lcMsgStr" &

if [ $llDialogRun -eq "1" ]; then

/usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text "
            $lcMsgStr               .
 " &

            GTKPIDts=$!
            ### kill GTKPIDts later
else
    ### code from HB.v.1.2 original , always with 'default' colors .
    B2T_Show_Splash "${lcMsgStr}..."
            GTKPIDts=${!}
            sleep .1
fi

    ####################################################################
    ### B2T_Tar_Opt is hard coded, now.
    ### We declare/assign value to var 'TAROPT' and 'TAREXT'
    ### gae,
    ###     simple default to "tar.gz" format for 'simple local backup'
    ###     with No Questions Asked.
    ####################################################################

    ###----'c'reate 'v'erbose 'z'ip)
    TAROPT="-c -z --checkpoint=1000"
    ### 'c'ompress 'z'ip 'checkpoints'

    lcMsgStr="-----------------------------" && Sys_Str2Trm "$lcMsgStr" "blu" "3"
    lcMsgStr="begin tar >>>>>>>>>>>>>>>>>>" && Sys_Str2Trm "$lcMsgStr" "red" "3"
    lcMsgStr="tar ${TAROPT}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    echo 
    lcMsgStr="Trg: ${lcPupSaveNameTrg}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    lcMsgStr="Src: ${lcPupSaveNameSrc}" && Sys_Str2Trm "$lcMsgStr" "pur" "3"
    lcMsgStr="trg=/initrd/mnt/dev_save/pup_UpupBB+20/upupbbsave-BB19+20-1202" && Sys_Str2Trm "$lcMsgStr" "yel" "3"
    echo 

    ### read
    ### good place for "read" to allow checking parameters
    ### in the GEANY "Execute" Terminal Window.
    sleep 1
    
    ### begin simple color string to terminal so tar process shows     
    /bin/echo -n -e ""  
    /bin/echo -n -e "\\033[1;36m" 

    ###------------------------------------------------------------
    ### begin: tar process  /initrd/mnt/dev_save/pup_UpupBB+20/upupbbsave-BB19+20-1202
    ###------------------------------------------------------------

    tar ${TAROPT} -f ${lcPupSaveNameTrg} ${lcPupSaveNameSrc}

    ###------------------------------------------------------------
    ### end: tar process
    ###------------------------------------------------------------

    /bin/echo -e "\\033[0;m" 
    ### end simple color string to terminal so tar process shows    

    lcMsgStr="trace: end  tar <<<<<<<<<<<<<<<<<<<<" && Sys_Str2Trm "$lcMsgStr" "red" "3"
    echo 


    RETVAL=$?   ### from 'tar' process.

    lcMsgStr="RETVAL= ${RETVAL} -------" && Sys_Str2Trm "$lcMsgStr" "yel" "3"

    lcTarRetVal="$RETVAL"   ### B2T standard var name.

    lcMsgStr="lcTarRetVal= $lcTarRetVal -------" && Sys_Str2Trm "$lcMsgStr" "yel" "3"

    ### parse for the 'RETVAL' from tar :  0=no-error , 1=error .
    if [ $lcTarRetVal -eq "1" ]; then
        echo
        echo "****** "
        echo "trace: (1) lcTarRetVal : File NOT Found ..."
        echo "******"

        #---------------------------------------------------------------
        #~ /usr/lib/gtkdialog/box_ok "ERROR" error "Tar File NOT Found Error ..."
        ### ERROR 'box_ok' clears itself, will not stop program.
        ###
        ### we decided to make this a "non-fatal" error ,
        ### the user should 'report' this error .
        ###
    fi

    ###--- B2T_Backup ------------------------------------------


###=====================================================================

        ### Before and After the 'tar' process , the subdir is different:
        ### this 'cd' "$CWDIR" is :
        ### after 'execute' tar
        ### after 'if' test on RetVal
        ### So, Main processes have run
        ### ... now, it is time to "change dir" back to 'home' subdir .
        ###

       lcMsgStr="cd  CWDIR= $ CWDIR  is $CWDIR <<<" && Sys_Str2Trm "$lcMsgStr" "grn" "3"
       lcMsgStr="cd  orig subdir in long 'path' form <<<" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

        cd "$CWDIR" ### point back to 'home' .

        lcMsgStr="Change Dir 'CWDIR' ... point back to 'home' dir " && Sys_Str2Trm "$lcMsgStr" "grn" "3"

        ###=====================================================================

        ###--- B2T_Backup -------
        ### to do : show the find Trg ${lcPupSaveNameTrg}
        ### lcFindFile="/mnt/home/${lcPupSaveNameTrg}"
        ### or make use of the 'RETVAL'.
        ###
        ### for now, prg is back in home directory, can find playbell
        ### We have the 'RETVAL' from tar :  0=no-error , 1=error .
        ###   and have checked for error flag.

        ### This is After 'tar' has run.


            ############################################################
            ### the Main Splash is still open as background
            ### other Splash will display inside the Main Splash.
            ############################################################

            #~ echo "DialogColor: ${lcDialogColor} ======="
            #~ echo "DialogRun: ${llDialogRun} ======="

########################################################################
###*** SPLASH: DONE ****************************************************
###*** SPLASH: DONE ****************************************************
###*** SPLASH: DONE ****************************************************

lcMsgStr="... B2T is DONE ..." && Sys_Str2Trm "$lcMsgStr" "red" "3"
lcDialogColor="  -fg yellow -bg blue  "

###~ /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "$lcMsgStr"

if [ $llDialogRun -eq "1" ]; then

/usr/lib/gtkdialog/box_splash  $lcDialogColor -close never -text "
       $lcMsgStr
 " &

            GTKPIDdone=${!}
            sleep 3

else
    ### code from HB.v.1.2 original , always with 'default' colors .
    B2T_Show_Splash "${lcMsgStr}..."
            GTKPIDdone=${!}
            sleep .1
            ### kill later.
fi

        ### These will overlay all previous splash
        ### and over the Main_Splash , 3 seconds,
        ### kill later.

###*********************************************************************

        ### wait for flash drive to shuffle data.
        echo "GtkDialog boxes will return 'terminated' message "
        #~ echo "... when the 'kill' PID command is applied"
        #~ echo "wait for USB-Flash-Drive to shuffle data at 10 MB per second ."
        ### box_splash width is 40, fill it so multiple splashes fit good.


###*********************************************************************

            ### Back-Step thru all "kill PID"
            ### Killing all previous splash in reverse order .

            ### kill near end of Main() 
            # sleep 1
            # kill ${GTKPIDmain}
            # echo "==========> kill GTKPIDmain ---"
            # ###

            sleep 1
            kill ${GTKPIDsp}
            echo "==========> kill GTKPIDsp ---"
            ###

            sleep 1
            kill ${GTKPIDts}
            echo "==========> kill GTKPIDts ---"
            ###

            ### kill near end of Main() 
            #~ kill ${GTKPIDdone}
            #~ echo "==========> kill GTKPIDdone ---"
            ###

    ### sync     ### write all buffered blocks to disk
                ### will lock if SnapMergePuppy is running. 
                ### will not run if PartEd is busy. 

    ### end : B2T_BackUpRun -------
    ### end : B2T_BackUpRun -------
}   ### end : B2T_BackUpRun -------
########################################################################


### all function() moved to top of code
### all function() moved to top of code
### all function() moved to top of code











########################################################################
#######    MAIN()   ####################################################
#######    MAIN()   ####################################################
#######    MAIN()   ####################################################
########################################################################


### Entry Main Splash to Terminal 
lcMsgStr=": B2U Main() : No Gui : Terminal Mode : "
Sys_Str2Trm "$lcMsgStr" "1" "1"
Sys_Str2Trm "$lcMsgStr" "2" "2"
Sys_Str2Trm "$lcMsgStr" "3" "3"
Sys_Str2Trm "$lcMsgStr" "4" "4"
Sys_Str2Trm "$lcMsgStr" "5" "5"
Sys_Str2Trm "$lcMsgStr" "6" "6"
Sys_Str2Trm "$lcMsgStr" "7" "7"

sleep 1

###################### Locate String
### ... Main()
### ... Main ()
### ... Main_()
###################### Locate String


########################################################################
### Now, continue through all normal Start-Up routines.
########################################################################


lcMsgStr="Path incl gtkdialog" && Sys_Str2Trm "$lcMsgStr" "red" "3"

PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/usr/lib/gtkdialog/:


########################################################################
###  begin B2T_lock_file  block  #######################################
###  begin B2T_lock_file  block  #######################################
###  begin B2T_lock_file  block  #######################################

### check on "already running" status ###
### B2T_check_lock_file
###   cannot be written as a subroutine
###   at this level of program stack
###   if we require a full 'exit' from B2T script.
### Stack will not 'pop' properly.
### Written into Main(), right here !
###    so that a single 'exit' will exit the program script totally .
### This is a 'clean' fix for a possible 'fatal' error .
###

    lcMsgStr="*** begin Main() B2T_LockFile ... " && Sys_Str2Trm "$lcMsgStr" "red" "3"

    ### gae, generate the name of the 'lock-file', unique to "B2T" program.
    ### declare / assign value to 'B2T_lockfile'
    B2T_lockfile="/tmp/B2T_backup_lock"
    B2T_lockval='0'

    if [ -f "$B2T_lockfile" ];then

        #------------------------------------------------------------------
        #~ /usr/lib/gtkdialog/box_ok "ERROR" -text "\
        #~ .        ... B2T_Running_Already
        #~ .        ... (1) Must Quit B2T program
        #~ .        ... (2) Must Clear Running B2T window
        #~ .        ... (3) Must Re-Start B2T program"
        #------------------------------------------------------------------

        ### if previous lockfile is found, then throw a flag, cleanup.
        ### B2T "Backup-2-Tar" is already running.
        ### User must clear lingering splash manually,
        ### then restart program. "
        ### box_ok requires user to hit the 'OK' button to clear box_ok splash.

        B2T_lockval="1"    ### raise error flag

        ### Developmental factors to consider :
        ### (1) leaving the lock-file in place, prevents re-running program.
        ### (2) removing the lock-file will allow a re-entry ...
        ###     then fresh re-entry can clear lock-file properly.
        ### Else,
        ### (3) the user can get locked-out because main script faulted fatally
        ###     and left the lock-file in place.
        ###     User will not know where to go to clear the lock-file.
        ### Therefore,
        ### (4) we leave the 'back-door' open for 're-entry'.
        ###--------------------------------------------------------------

        ### file unlock
        rm -r "${B2T_lockfile}"  ### release 'running' status.

        ### rationale :
        ### this allows user to ReStart.
        ### User has been warned,
        ### but, this also allows next run program to be a possible 'twice' run.
        ### thus, the user will not be 'locked-out' of next program 'run'.

        exit 1      ### this WILL exit from B2T script ... this is Good!

        ### ideally,
        ###     user will wait for current session to finish.
        ###     then restart 'B2T' program.
        ### else
        ###     user will clear lingering splash, manually.
        ###     then restart 'B2T' program.
        ###
        ### Current 'lock-file' method will allow user to 're-start' B2T
        ###     even though there may be a 'currently running' session.
        ###     We find no 'fatal' problems,
        ###     other than useless 'double-up' on back-up process.
        ###
        ### Otherwise, if B2T faults, does not remove the lock-file
        ###     then 're-entry' is not possible.
        ###     Then, the only fix is to call the IT tech
        ###     to manually 'rm' the lock-file.
        ### There are logical issues here, with some solutions,
        ### but that is getting beyond the scope of the B2T process.
        ###
    fi

    ### so,  RESET the lock-file, via 'touch',
    ###     and keep running .
    touch "${B2T_lockfile}"
    ### remove this lockfile at end of "QUIT", bottom of code.
    ### at the 'base' level of program stack.

###  end B2T_lock_file block  ##########################################
###  end B2T_lock_file block  ##########################################
###  end B2T_lock_file block  ##########################################
########################################################################

###^^^ Main() ^^^^^^^

### At this point, B2T is OK to activate.
### gather all values required for running.


### At this point, B2T is OK to activate.
### gather all values required for running.

lcMsgStr=">>> call B2T_StartUp" && Sys_Str2Trm "$lcMsgStr" "grn" "3"

B2T_StartUp

    if [ $PUPMODE -eq 13 ] ; then
        lcDummy=0
    fi

lcMsgStr=">>> call B2T_BackUpRun " && Sys_Str2Trm "$lcMsgStr" "grn" "3"

###^^^ Main() ^^^^^^^
### run the Primary subroutine function "B2T_BackUpRun" with two param :

B2T_BackUpRun "$B2T_PUPSAVE_PATH" "$B2T_BACKUP_PATH"

###^^^ Main() ^^^^^^^
### Cleanup 

    ########################################
    kill ${GTKPIDdone}
    ########################################
    ### real run will include this kill for main-splash 
    kill ${GTKPIDmain}
    ########################################

    echo
    lcMsgStr="==========> All pid are cleared <===============..."
    Sys_Str2Trm "$lcMsgStr" "cyn" "7"
    echo


lcMsgStr="<<< Back from B2T_BackUpRun " && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    lcMsgStr="Cleanup ... B2T_unlock ..." && Sys_Str2Trm "$lcMsgStr" "grn" "3"

    rm -r "${B2T_lockfile}"  ### release 'running' status.

    lcMsgStr=">>>       End : EXIT:QUIT           <<<" && Sys_Str2Trm "$lcMsgStr" "red" "3"

###^^^ Main() ^^^^^^^
### send ending message to Terminal
    ### This display is for the Ending of the Terminal DeBug Session : 
    echo
    echo
    echo
    lcMsgStr="... B2U : ReadMe ! ... ${gcVerDts} ..." && Sys_Str2Trm "${lcMsgStr}" "grn" "7"
    lcMsgStr="...         Tar has Created 'tar.gz' BackUp" && Sys_Str2Trm "${lcMsgStr}" "yel" "7"
    lcMsgStr="...         Wait for USB devices to flush" && Sys_Str2Trm "${lcMsgStr}" "pur" "7"
    echo
    lcMsgStr=">>>  Hit 'Enter' to clear Terminal <<< "
    Sys_Str2Trm "$lcMsgStr" "yel" "7"
    Sys_Str2Trm "$lcMsgStr" "grn" "7"
    Sys_Str2Trm "$lcMsgStr" "cyn" "7"
    echo
    sleep 3


###^^^ Main() ^^^^^^^
### run thru to bottom/end 

    ### Options: 
	### $0 & ### to reenter ### re-run this program
    ###  exit 0 ### to prevent stack overflow.


### If returning here 
### then Simply Fall-Out of the B2T script with 'exit 0' 
exit 0

########################################################################
########################################################################
#=======================================================================
### end: main()
#=======================================================================
########################################################################
########################################################################


########################################################################
### gae, Geany  debug method :
### [ "Execute" for BASH-Terminal-Trace-Window ]
### write "echo" commands for tracing in the Terminal Window.
########################################################################


########################################################################
### end of B2T 'Back-2-Tar' program
#=======================================================================
### END ###### END ###### END ###### END ###### END ###### END ######
########################################################################



